<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ page language="java" contentType="text/html; charset=EUC-KR" pageEncoding="EUC-KR" %>
<%@ page import="java.util.List, java.util.*, com.rsm.twins.xml.node.*, com.rsm.twins.vo.*" %>

<%@ include file="/CONTENTS/common/includeSessionMenuManager.jsp" %>
<jsp:useBean id="commonVO" scope="request" class="com.rsm.twins.vo.CommonVO" />

<% boolean bModify = false;
   List moduleList = sessionMenuManager.getMasterModuleList();
   Map taskVOMap = (Map)commonVO.getValue(Constants.TASK_VO_MAP);
   if( taskVOMap != null) bModify = true;
  
%>

<%! private String checkDisplay(boolean b, Map taskVOMap, String taskID, int gubun){
    //gubun: 1 = Read, 2 = Create, 3 = Update, 4 = Delete, 5 = Print
		String result = "";
		if(b){
			GroupTaskVO taskVO = (GroupTaskVO)taskVOMap.get(taskID);
			if(taskVO != null ){
				switch(gubun){
					case 1:
						if ( taskVO.getPrivRead().equals("Y") )     result = "checked";
						break;
					case 2:
						if ( taskVO.getPrivCreate().equals("Y") )	result = "checked";
						break;
					case 3:
						if ( taskVO.getPrivUpdate().equals("Y") )	result = "checked";
						break;
					case 4:
						if ( taskVO.getPrivDelete().equals("Y") )	result = "checked";
						break;
					case 5:
						if ( taskVO.getPrivPrint().equals("Y") )	result = "checked";
						break;
				}
			}
		}
		
		return result;
	}
%>
<script>
function moduleCheck(menu,size,num,total,leng)
{
	var result = false;
	var i = 0;
	var j = 0;
	
	if(dataForm.checkModule[leng].checked)
	{
		result = true;
	}
	if(leng ==0)//Intro ϰ...
	{
		menu = 1;
		num = 1;
	}
	for (i=parseInt(menu); i < parseInt(size); i++)
	{		
		dataForm.checkMenu[i].checked = result;	
	}
	
	for (j=parseInt(num); j < parseInt(total); j++)
	{		
		dataForm.checkTask[j].checked = result;
		taskCheck(j);		
	}
}

function menuCheck(num,menu,leng)
{
//alert(num+","+menu+","+leng);
	var result = false;
	if(dataForm.checkMenu[leng].checked)
	{
		result = true;
	}

	for (var i=parseInt(num); i < parseInt(menu); i++)
	{		
		dataForm.checkTask[i].checked = result;
		taskCheck(i);		
	}
}
function taskCheck(num)
{
	var result = false;
	if(dataForm.checkTask[num].checked)
	{
		result = true;
	}
	authCheck(result, num);
}

function authCheck(result,num)
{
	dataForm.checkRead[num].checked = result;
	dataForm.checkCreate[num].checked = result;
	dataForm.checkUpdate[num].checked = result;
	dataForm.checkDelete[num].checked = result;
	dataForm.checkPrint[num].checked = result;
}

function menuCheckVal(num,menu,leng)
{
	for (var i=parseInt(num); i < parseInt(menu); i++)
	{	
		if( i >0 && dataForm.checkTask[parseInt(i)].checked) 
		{
			dataForm.checkMenu[leng].checked = true;	
		}	
	}
}
function moduleCheckVal(num,menu,leng)
{
	for (var i=parseInt(num); i < parseInt(menu); i++)
	{
		if( dataForm.checkMenu[parseInt(i)].checked) 
		{
			if(leng > 0)
			{
				dataForm.checkModule[parseInt(leng)].checked = true;	
			}
			else
			{
				dataForm.checkModule.checked = true;	
			}
		}	
	}	
}
</script>
<br>
  <!--Table Title -->
  <table  border="0" cellpadding="0" cellspacing="1" class=Tbl01_line width="100%">
      <tr class=Tbl01_head1> 
        <td width="150" ><%//%><bean:message key='name.admn.group.modules'/></td>
        <td width="150" ><%//޴%><bean:message key='name.admn.group.menu'/></td>
        <td width="230" ><%//½ũ%><bean:message key='name.admn.group.task'/></td>
        <td width="*" ><%//󼼱%><bean:message key='name.admn.group.detail'/></td>
      </tr>
  </table>
  
  <!--Task -->
  <div id="A" style="position:relative; left:0px; top:0px; width:968px; height:300px; z-index:1; overflow: auto; visibility: visible"> 
    <table width="946" class="TblA" style="border-collapse:collapse; border-right-width:1; border-right-color:#ACB4C7; border-right-style:solid;" cellpadding="1" border="1" cellspacing="0" bordercolor="ACB4C7" >
    <%
    	int num = 0;
    	int menuVal = 0;
    	int moduleVal = 0;
    	for(int i=0; i < moduleList.size();i++){ 
        Module module = (Module)moduleList.get(i);
        List menuList = module.getChildList();
     	for(int j=0; j < menuList.size(); j++){
     		Menu menu = (Menu)menuList.get(j);
     		List subMenuList = menu.getChildList();
     		int subMenuSize = subMenuList.size();
     		for(int k=0; k < subMenuSize; k++ ){
     			SubMenu subMenu = (SubMenu)subMenuList.get(k);
     			//SubMenuȿ ϳ Task ִٰ Ѵ.
     			Task task = (Task)subMenu.getChildList().get(0);
      %>
      <tr>
      	<%if(j==0 && k==0){%>
      	<td rowspan="<%=module.getTaskSizeForModule()%>" width="150" align="center">
      		<input type="checkbox" name="checkModule" onClick="moduleCheck('<%=menuVal%>','<%=menuVal+menuList.size()%>','<%=num%>','<%=num+module.getTaskSizeForModule()%>',<%=moduleVal%>)" >
      		<bean:message key='<%=module.getId()%>'/>
      	</td>
      	<%}%>
        <%if(k == 0){ %>
        <td rowspan="<%=subMenuSize%>" width="150">
			<input type="checkbox" name="checkMenu" onClick="menuCheck('<%=num%>','<%=num+subMenuSize%>',<%=menuVal%>)" <%if(task.getId().equals(Constants.FIRST_TASK)){%>disabled checked<%}%> >
        	<bean:message key='<%=module.getId() + "." + menu.getId() %>'/>
        </td>
        <%}//end if%>
        <td width="230"> 
          <input type="checkbox" name="checkTask" onClick="taskCheck('<%=num%>')" <%if(task.getId().equals(Constants.FIRST_TASK)){%>disabled checked<%}%> <%= checkDisplay(bModify, taskVOMap, task.getId(), 1 ) %>>
          <bean:message key='<%= module.getId() + "." + menu.getId() + "." + subMenu.getId() + "." + task.getId() %>'/>
        </td>
        <td width="*"> 
          <table width="98%" border="0" cellspacing="0" cellpadding="0" >
            <tr> 
			  <%if(task.getId().equals(Constants.FIRST_TASK)){%>
              <td >
                <input type="checkbox" name="checkRead" value="<%=task.getId()%>" disabled checked>
                <%//ȸ%><bean:message key='name.normal'/></td>
              <td> 
                <input type="checkbox" name="checkCreate" value="<%=task.getId()%>" disabled>
                <%//%><bean:message key='name.create'/></td>
              <td> 
                <input type="checkbox" name="checkUpdate" value="<%=task.getId()%>" disabled>
                <%//%><bean:message key='name.modify'/></td>
              <td> 
                <input type="checkbox" name="checkDelete" value="<%=task.getId()%>" disabled>
                <%//%><bean:message key='name.delete'/></td>
              <td> 
                <input type="checkbox" name="checkPrint"  value="<%=task.getId()%>" disabled>
                <%//μ%><bean:message key='name.button.print'/></td>                
              <%} else{%>
              <td >
                <input type="checkbox" name="checkRead" value="<%=task.getId()%>" disabled <%= checkDisplay(bModify, taskVOMap, task.getId(), 1 ) %>>
                <%//ȸ%><bean:message key='name.normal'/></td>
              <td> 
                <input type="checkbox" name="checkCreate" value="<%=task.getId()%>" disabled <%= checkDisplay(bModify, taskVOMap, task.getId(), 2 ) %>>
                <%//%><bean:message key='name.create'/></td>
              <td> 
                <input type="checkbox" name="checkUpdate" value="<%=task.getId()%>" disabled <%= checkDisplay(bModify, taskVOMap, task.getId(), 3 ) %>>
                <%//%><bean:message key='name.modify'/></td>
              <td> 
                <input type="checkbox" name="checkDelete" value="<%=task.getId()%>" disabled <%= checkDisplay(bModify, taskVOMap, task.getId(), 4 ) %>>
                <%//%><bean:message key='name.delete'/></td>
              <td> 
                <input type="checkbox" name="checkPrint" value="<%=task.getId()%>" disabled <%= checkDisplay(bModify, taskVOMap, task.getId(), 5 ) %>>
                <%//μ%><bean:message key='name.button.print'/></td>
              <%}%>
            </tr>
          </table>
        </td>
      </tr>
        <%       
        num++;       
        }// end for submenu %>
      <%
      int menuSize =num-subMenuSize;
      out.println("<SCRIPT LANGUAGE=JavaScript>menuCheckVal("+menuSize+','+num+','+menuVal+");</SCRIPT>"); 
      menuVal++;	      
      }// end for menu %>
    <%
    int moduleSize = menuVal-menuList.size();
    out.println("<SCRIPT LANGUAGE=JavaScript>moduleCheckVal("+moduleSize+','+menuVal+','+moduleVal+");</SCRIPT>"); 
    moduleVal++;   
    }//end for module %>
    </table>
  </div>

