
<%@ page language="java" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.sql.*" %>
<%@ page import="javax.sql.*" %>
<%@ page import="javax.naming.*" %>
<%

	String contextName = "jdbc/rpmsDS"; // 웹로직 JNDI Name (캡쳐 이미지 참고)
	String testSQL = "SELECT COUNT(*) CNT FROM TWINS_USER WHERE ROWNUM = 1"; // 임의의 테이블 조회하는 쿼리
	
	DataSource ds = null;
	Connection conn = null;
	PreparedStatement pstmt = null;
	ResultSet rs = null;
	
	Context initContext = new InitialContext();
				
	try {
		ds = (DataSource)initContext.lookup(contextName); // 웹로직 DataSource를 가져온다
		conn = ds.getConnection(); // DB Connection을 가져온다
		pstmt = conn.prepareStatement(testSQL); 
		rs = pstmt.executeQuery(); // 쿼리 실행
		if(rs.next()) {
			out.println("Connection OK!"); // 데이터가 1건이상 있으면 OK 출력
		} else {
			out.println("DB Connection Test Error!"); // 데이터가 없으면 Error 출력
		}		
	} catch (Exception e) {
		out.println("DB Connection Error!"); // Exception이 발생할 경우 Error 출력
		e.printStackTrace();
	} finally {
		if(rs != null) try { rs.close(); } catch (Exception e) {}
		if(pstmt != null) try { pstmt.close(); } catch (Exception e) {} 
		if(conn != null) try { conn.close(); } catch (Exception e) {} 	
	}
	
	out.println("<BR/>");
	
%>


